#!/bin/env python
# -*- coding: utf-8 -*-

# ------------------------------------------------------------
# opensecurity-dialog
# 
# an opensecurity dialog
#
# Autor: Oliver Maurhart, <oliver.maurhart@ait.ac.at>
#
# Copyright (C) 2013, 2014 AIT Austrian Institute of Technology
# AIT Austrian Institute of Technology GmbH
# Donau-City-Strasse 1 | 1220 Vienna | Austria
# http://www.ait.ac.at
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation version 2.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, 
# Boston, MA  02110-1301, USA.
# ------------------------------------------------------------


# ------------------------------------------------------------
# imports

import argparse
import os
import sys

from PyQt4 import QtCore
from PyQt4 import QtGui

# local
from ui import *


# ------------------------------------------------------------
# code


def main():
    
    # parse command line
    parser = argparse.ArgumentParser(description = 'OpenSecurity Dialog.')
    parser.add_argument('mode', metavar='MODE', help='dialog mode: \'password\', \'credentials\', \'notification-information\', \'notification-warning\' or \'notification-critical\'')
    parser.add_argument('text', metavar='TEXT', help='text to show')
    args = parser.parse_args()
    
    a = QtGui.QApplication(sys.argv)
    
    if args.mode == 'password':
        d = PasswordDialog(args.text)
    
    if args.mode == 'credentials':
        d = CredentialsDialog(args.text)
    
    if args.mode == 'notification-information':
        d = NotificationDialog('OpenSecurity Information', args.text)
    
    if args.mode == 'notification-warning':
        d = NotificationDialog('OpenSecurity Warning', args.text)
    
    if args.mode == 'notification-critical':
        d = NotificationDialog('OpenSecurity Criticali Message', args.text)
        
    if not 'd' in locals():
        sys.stderr.write('unknown mode. type --help for help\n')
        sys.exit(1)
    
    # pop up the dialog
    d.show()
    a.exec_()
    
    # give proper result code
    if d.result() == QtGui.QDialog.Accepted:
        res = 0
    else:
        res = 1
    sys.exit(res)
    

# start
if __name__ == "__main__":
    main()

